package org.apache.commons.lang3.time;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.text.ParsePosition;
import java.util.Calendar;
import org.apache.commons.lang3.time.FastDateParser;

class NumberStrategy extends FastDateParser.Strategy {
  private final int field;
  
  NumberStrategy(int field) {
    this.field = field;
  }
  
  boolean isNumber() {
    return true;
  }
  
  boolean parse(FastDateParser parser, Calendar calendar, String source, ParsePosition pos, int maxWidth) {
    int idx = pos.getIndex();
    int last = source.length();
    if (maxWidth == 0) {
      for (; idx < last; idx++) {
        char c = source.charAt(idx);
        if (!Character.isWhitespace(c))
          break; 
      } 
      pos.setIndex(idx);
    } else {
      int end = idx + maxWidth;
      if (last > end)
        last = end; 
    } 
    for (; idx < last; idx++) {
      char c = source.charAt(idx);
      if (!Character.isDigit(c))
        break; 
    } 
    if (pos.getIndex() == idx) {
      pos.setErrorIndex(idx);
      return false;
    } 
    int value = Integer.parseInt(source.substring(pos.getIndex(), idx));
    pos.setIndex(idx);
    calendar.set(this.field, modify(parser, value));
    return true;
  }
  
  int modify(FastDateParser parser, int iValue) {
    return iValue;
  }
  
  public String toString() {
    return "NumberStrategy [field=" + this.field + "]";
  }
}
